import javax.swing.*;
import java.awt.*;

class Main {

  static final int SCRWIDTH = 800;
  static final int SCRHEIGHT = 600;

  static Painting painting;
  public static void main(String[] args) {
    painting = new Painting();
    painting.setPreferredSize(new Dimension(SCRWIDTH, SCRHEIGHT));
    painting.setSize(new Dimension(SCRWIDTH, SCRHEIGHT));
    JFrame frame = new JFrame();
    frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    frame.add(painting);
    frame.pack();
    frame.setVisible(true);

    Engine tracer = new Engine();
    Surface surface = new Surface(SCRWIDTH, SCRHEIGHT, painting);
    painting.setImage(surface.GetBuffer());
    
    surface.Clear(0);
    surface.InitCharset();
    tracer.GetScene().InitScene();
    tracer.SetTarget(surface.GetBuffer(), SCRWIDTH, SCRHEIGHT);

    surface.Print( "Timing:", 2, 2, 0xffffff );
    long fstart = System.currentTimeMillis();
    tracer.InitRender();
    while (!tracer.Render()) {
      frame.repaint();
    }
    long ftime = System.currentTimeMillis() - fstart;
    StringBuffer t = new StringBuffer("00:00.000");
    t.setCharAt(6, (char)((ftime / 100) % 10 + '0'));
    t.setCharAt(7, (char)((ftime / 10) % 10 + '0'));
    t.setCharAt(8, (char)((ftime % 10) + '0'));
    long secs = (ftime / 1000) % 60;
    long mins = (ftime / 60000) % 100;
    t.setCharAt(3, (char)(((secs / 10) % 10) + '0'));
    t.setCharAt(4, (char)((secs % 10) + '0'));
    t.setCharAt(1, (char)((mins % 10) + '0'));
    t.setCharAt(0, (char)(((mins / 10) % 10) + '0'));
    surface.Print( t.toString(), 60, 2, 0xffffff );
    frame.repaint();
  }
}
 