
class PlanePrim extends Primitive {

  public Type GetType() {
    return Type.PLANE;
  }
  public PlanePrim( vector3 a_Normal, float a_D )  {
    m_Plane = new plane( a_Normal, a_D );
  }
  public vector3 GetNormal() {
    return m_Plane.N;
  }
  public float GetD() {
    return m_Plane.D;
  }

  public int Intersect( Ray a_Ray, float[] a_Dist) {
    float d = common.DOT( m_Plane.N, a_Ray.direction );
    if (d != 0) {
      float dist = -(common.DOT( m_Plane.N, a_Ray.origin ) + m_Plane.D) / d;
      if (dist > 0) {
        if (dist < a_Dist[0]) {
          a_Dist[0] = dist;
          return HIT;
        }
      }
    }
    return MISS;
  }

  public vector3 GetNormal( vector3 a_Pos ) {
    return m_Plane.N;
  }


  private plane m_Plane;
}

