
abstract class Primitive {

  // Intersection method return values
  final int HIT = 1;              // Ray hit primitive
  final int MISS = 0;             // Ray missed primitive
  final int INPRIM = -1;          // Ray started inside primitive

  public enum Type {
    SPHERE,
    PLANE
  }
  public Primitive() {
    m_Light = false;
    m_Material = new Material();
  }
  public Material GetMaterial() {
    return m_Material;
  }
  public void SetMaterial( Material a_Mat ) {
    m_Material = a_Mat;
  }
  public abstract Type GetType();
  public abstract int Intersect( Ray a_Ray, float[] a_Dist );
  public abstract vector3 GetNormal( vector3 a_Pos );
  public Color GetColor( vector3 v ) {
    return m_Material.GetColor();
  }
  public void Light( boolean a_Light ) {
    m_Light = a_Light;
  }
  public boolean IsLight() {
    return m_Light;
  }
  public void SetName( String a_Name ) {
    m_Name = a_Name;
  }
  public String GetName() {
    return m_Name;
  }

  protected Material m_Material;
  protected String m_Name;
  protected boolean m_Light;
}
