
class Sphere extends Primitive {

  public Type GetType() {
    return Type.SPHERE;
  }
  public Sphere( vector3 a_Centre, float a_Radius ) {
    m_Centre = a_Centre;
    m_SqRadius = a_Radius * a_Radius;
    m_Radius = a_Radius;
    m_RRadius = 1 / a_Radius;
  }
  public vector3 GetCentre() {
    return m_Centre;
  }
  public float GetSqRadius() {
    return m_SqRadius;
  }
  public vector3 GetNormal( vector3 a_Pos ) {
    vector3 result = a_Pos.sub(m_Centre);
    result.mulAssign(m_RRadius);
    return result;
  }

  public int Intersect( Ray a_Ray, float[] a_Dist ) {
    vector3 v = a_Ray.origin.sub(m_Centre);
//    float b = -common.DOT( v, a_Ray.direction );
    float b = -(v.x * a_Ray.direction.x + v.y * a_Ray.direction.y + v.z * a_Ray.direction.z);
//    float det = (b * b) - common.DOT( v, v ) + m_SqRadius;
    float det = (b * b) - (v.x * v.x + v.y * v.y + v.z * v.z) + m_SqRadius;
    int retval = MISS;
    
    if (det > 0) {
      det = (float) Math.sqrt( det );
      float i1 = b - det;
      float i2 = b + det;
      if (i2 > 0) {
        if (i1 < 0) {
          if (i2 < a_Dist[0]) {
            a_Dist[0] = i2;
            retval = INPRIM;
          }
        } else {
          if (i1 < a_Dist[0]) {
            a_Dist[0] = i1;
            retval = HIT;
          }
        }
      }
    }
    return retval;
  }


  private vector3 m_Centre = new vector3();
  private float m_SqRadius, m_Radius, m_RRadius;
}

