import java.util.ArrayList;

class Scene {
  public Scene() { }
  public ArrayList<Primitive> primitives() {
    return m_Primitives;
  }
  public void SphereTree( int a_Prim, float a_Radius, vector3 a_Pos, int a_Depth ) {
  }
  public void InitScene() {
    Primitive prim;

    // ground plane
    prim = new PlanePrim( new vector3( 0.0f, 1.0f, 0.0f ), 4.4f );
    prim.SetName( "plane" );
    prim.GetMaterial().SetReflection( 0.0f );
    prim.GetMaterial().SetRefraction( 0.0f );
    prim.GetMaterial().SetDiffuse( 1.0f );
    prim.GetMaterial().SetColor( new Color( 0.4f, 0.3f, 0.3f ) );
    m_Primitives.add(prim);
    // big sphere
    prim = new Sphere( new vector3( 2, 0.8f, 3 ), 2.5f );
    prim.SetName( "big sphere" );
    prim.GetMaterial().SetReflection( 0.2f );
    prim.GetMaterial().SetRefraction( 0.8f );
    prim.GetMaterial().SetRefrIndex( 1.3f );
    prim.GetMaterial().SetColor( new Color( 0.7f, 0.7f, 1.0f ) );
    m_Primitives.add(prim);
    // small sphere
    prim = new Sphere( new vector3( -5.5f, -0.5f, 7f ), 2 );
    prim.SetName( "small sphere" );
    prim.GetMaterial().SetReflection( 0.5f );
    prim.GetMaterial().SetRefraction( 0.0f );
    prim.GetMaterial().SetRefrIndex( 1.3f );
    prim.GetMaterial().SetDiffuse( 0.1f );
    prim.GetMaterial().SetColor( new Color( 0.7f, 0.7f, 1.0f ) );
    m_Primitives.add(prim);
    // light source 1
    prim = new Sphere( new vector3( 0, 5, 5 ), 0.1f );
    prim.SetName( "light 1" );
    prim.Light( true );
    prim.GetMaterial().SetColor( new Color( 0.4f, 0.4f, 0.4f ) );
    m_Primitives.add(prim);
    // light source 2
    prim = new Sphere( new vector3( -3, 5, 1 ), 0.1f );
    prim.SetName( "light 2" );
    prim.Light( true );
    prim.GetMaterial().SetColor( new Color( 0.6f, 0.6f, 0.8f ) );
    m_Primitives.add(prim);
    // extra sphere
    prim = new Sphere( new vector3( -1.5f, -3.8f, 1 ), 1.5f );
    prim.SetName( "extra sphere" );
    prim.GetMaterial().SetReflection( 0.0f );
    prim.GetMaterial().SetRefraction( 0.8f );
    prim.GetMaterial().SetColor( new Color( 1.0f, 0.4f, 0.4f ) );
    m_Primitives.add(prim);
    // back plane
    prim = new PlanePrim( new vector3( 0.4f, 0, -1 ), 12 );
    prim.SetName( "back plane" );
    prim.GetMaterial().SetReflection( 0.0f );
    prim.GetMaterial().SetRefraction( 0.0f );
    prim.GetMaterial().SetSpecular( 0 );
    prim.GetMaterial().SetDiffuse( 0.6f );
    prim.GetMaterial().SetColor( new Color( 0.5f, 0.3f, 0.5f ) );
    m_Primitives.add(prim);
    // ceiling plane
    prim = new PlanePrim( new vector3( 0, -1, 0 ), 7.4f );
    prim.SetName( "back plane" );
    prim.GetMaterial().SetReflection( 0.0f );
    prim.GetMaterial().SetRefraction( 0.0f );
    prim.GetMaterial().SetSpecular( 0 );
    prim.GetMaterial().SetDiffuse( 0.5f );
    prim.GetMaterial().SetColor( new Color( 0.4f, 0.7f, 0.7f ) );
    m_Primitives.add(prim);
    // grid
    for ( int x = 0; x < 8; x++ ) {
      for ( int y = 0; y < 7; y++ ) {
        prim = new Sphere( new vector3( -4.5f + x * 1.5f, -4.3f + y * 1.5f, 10 ), 0.3f );
        prim.SetName( "grid sphere" );
        prim.GetMaterial().SetReflection( 0 );
        prim.GetMaterial().SetRefraction( 0 );
        prim.GetMaterial().SetSpecular( 0.6f );
        prim.GetMaterial().SetDiffuse( 0.6f );
        prim.GetMaterial().SetColor( new Color( 0.3f, 1.0f, 0.4f ) );
        m_Primitives.add(prim);
      }
    }
  }

  private ArrayList<Primitive> m_Primitives = new ArrayList<Primitive>();
}


