
class vector3 {
  public vector3() {
  }
  
  public vector3( float a_X, float a_Y, float a_Z ) {
    x = a_X;
    y = a_Y;
    z = a_Z;
  }

  public vector3( vector3 v ) {
    x = v.x;
    y = v.y;
    z = v.z; 
  }

  public void Set( float a_X, float a_Y, float a_Z ) {
    x = a_X; 
    y = a_Y;
    z = a_Z;
  }
  public void Set( vector3 v ) {
    x = v.x;
    y = v.y;
    z = v.z;
  }
  public void Normalize() {
    float l = 1.0f / Length();
    x *= l;
    y *= l;
    z *= l;
  }

  public float Length() {
    return (float)Math.sqrt( x * x + y * y + z * z );
  }
  public float SqrLength() {
    return x * x + y * y + z * z;
  }
  public float Dot( vector3 a_V ) {
    return x * a_V.x + y * a_V.y + z * a_V.z;
  }
  public vector3 Cross( vector3 b ) {
    return new vector3( y * b.z - z * b.y, z * b.x - x * b.z, x * b.y - y * b.x );
  }
  public void addAssign( vector3 a_V ) {
    x += a_V.x;
    y += a_V.y;
    z += a_V.z;
  }
  public void subAssign( vector3 a_V ) {
    x -= a_V.x;
    y -= a_V.y;
    z -= a_V.z;
  }
  public void mulAssign( float f ) {
    x *= f;
    y *= f;
    z *= f;
  }
  public void mulAssign( vector3 a_V ) {
    x *= a_V.x;
    y *= a_V.y;
    z *= a_V.z;
  }
  public vector3 negate() {
    return new vector3( -x, -y, -z );
  }
  public vector3 add( vector3 v2 ) {
    return new vector3( x + v2.x, y + v2.y, z + v2.z );
  }
  public vector3 sub( vector3 v2 ) {
    return new vector3( x - v2.x, y - v2.y, z - v2.z );
  }
  public vector3 mul( float f ) {
    return new vector3( x * f, y * f, z * f );
  }
  public vector3 mul( vector3 v2 ) {
    return new vector3( x * v2.x, y * v2.y, z * v2.z );
  }
  public String toString() {
    return z + "," + y + "," + z;
  }

  public float x = 0f;
  public float y = 0f;
  public float z = 0f;

}

